package scalapi.jdk.io

import java.util.zip.{ZipInputStream, ZipEntry}

object ZipInputStreams {

  def mapEntries[T](zipInputStream: ZipInputStream)(entryHandler: ZipEntry => T): Seq[T] =
    Stream.continually(zipInputStream.getNextEntry).
      takeWhile(_ != null).
      map(entry => entryHandler(entry))

  def forEachEntry(zipInputStream: ZipInputStream)(entryHandler: ZipEntry => Unit) {
    Stream.continually(zipInputStream.getNextEntry).
      takeWhile(_ != null).
      foreach(entry => entryHandler(entry))
  }

}
